/* main */

void input(int run_option, char *ccmfile);
void define(void);
void obtain(void);


/* define */

void recursiveClusteringFunction(int **configuration, 
				 int length, 
				 int maxorder, 
				 int &NumberConnected);

int findDescriptorIndex(int *descriptor,
			int NumberConnected);

/* bookKeeping */

int seconds(void);
void initDivisors(void);
int findUniqueDescriptorOfCluster(int order,
             int **configuration, int *descriptor);

void printOutDescriptor(int *descriptor);

void printOutClusterFromDescriptor(int *descriptor);

void printOutCluster(int length, int **configuration);

void symmetryGroup(int switchVariable, 
		   int order,
		   int **configuration,
		   int (*tempConfiguration)[5]); // changed by Joerg Sep05


void findCartesiansFromGeneralisedPosition(double &x, 
					   double &y, 
					   double &z, 
					   int *configuration);

void findConfigurationToDescriptor(int *descriptor,
				   int (*config)[5], // x y z uc
				   int order); 

int findClusterFromDescriptor(int *descriptor, int **configuration);

void binary(int index, int length, int *spin);
void trimary(int index1, int index2, int index3, int length, int *spin);
void quartary(int index1, int index2, int index3, int length, int *spin);

void obtainDisconnectedClusters(int &NumberDisconnected, 
				int NumberConnected);

void updateDescriptors(int *descriptor,
		       int numberElements);

/* new routines for higher spin + define */

int findDescriptorIndex2(int *descriptor,int numberElements);
void updateDescriptors2(int *descriptor,int numberElements);
void findFundamentalSpinConfigurations(void);
void findSpinState(int *descriptor, int *spinState);

/* collect */

void collect(void);

/* solve */

void solve(void);
void usrfun(int n, double *fvec, double **fjac, double *x, 
		     int iterations);

void definePointsInBT(void);
void findBraEquations(double **m, double *x);
double findStagMag(double *x, double *bra_x,  double *subLatticeMag);
void sublattice_term(int length, 
		     int **string,
		     int *subTerm);
double findEnergy(double *x);
void   findBraStateRHS(double *rhs, double *x);
int directIteration(int maximumNumIterations, 
		    int numConfigs, 
		    double tolerance,
		    int &iterations, 
		    double *oldX);

int directIterationBraState(int maximumNumIterations, 
			    int numConfigs, 
			    double tolerance,
			    int &iterations, 
			    double *oldX,
			    double *oldBraX);
void findBraState(double *x, double *bra_x);
